
//Safe string: URI Encode + securing special SQL characters
//toSafeString(): Replaces SQL characters and then does URI Encode. Also replaces " with '
//toOrigString(): URI Decode and then SQL character restore
//usage: 
// on request: userString="'" + toSafeString("whatever") + "',"+ toSafeString("and so on")
// on response: allClients=JSON.parse(toOrigString(xhttp.responseText));

var replacementMap=[{orig:"X", safe:"Xa", safeShort:"a"},{orig:"!", safe:"Xb", safeShort:"b"},{orig:"_", safe:"Xc", safeShort:"c"},{orig:"%", safe:"Xd", safeShort:"d"},{orig:"'", safe:"Xe", safeShort:"e"}]; 
	
var allUserAccountList;
var allUserAccountListReady=false;
var allRoomsList;
var allRoomsListReady=false;
var loginReady=false;

function toOrigString(inString)
{
	var outString="";
	var inLength = inString.length;
	var copyPosition=0;
	var position = inString.indexOf("X");
	var i;
	
	inString=decodeURIComponent(inString);
	while (position>-1)
	{
		outString=outString+inString.substring(copyPosition, position);
		for (i=0;i<replacementMap.length; i++)
		{
			if (inString.charAt(position+1)==replacementMap[i].safeShort) 
			{ 
				outString=outString+replacementMap[i].orig;
			}
		}
		copyPosition=position+2;
		position=inString.indexOf("X",position+2);
	}
	outString=outString+inString.substring(copyPosition);	
	return outString;
}
	
function toSafeString(inString)
{
	var outString="";
	var i;
	var found;
	
	
	outString=inString;
	while (outString.indexOf("\"")>-1) outString=outString.replace("\"","'");
	
	for (i=0;i<replacementMap.length; i++)
	{
		found=outString.indexOf(replacementMap[i].orig);
		while (found>-1)
		{
  	      outString=outString.substring(0,found)+replacementMap[i].safe+outString.substring(found+1);
		   found=outString.indexOf(replacementMap[i].orig,found+1);
		}
	}
	
	while ((outString.charCodeAt(outString.length-1)==13) || (outString.charCodeAt(outString.length-1)==10)) outString=outString.substring(0,outString.length-1);
	   
	return encodeURIComponent(outString);
}
	

function addAccount(account)
{
	var xhttp = new XMLHttpRequest();
	var userString="";
	userString=userString+"'"+toSafeString(account.firstName)+"',";
	userString=userString+"'"+toSafeString(account.lastName)+"',";
	userString=userString+"'"+toSafeString(account.accountName)+"',";
	userString=userString+"'"+toSafeString(account.email)+"',";
	userString=userString+"'"+toSafeString(account.school)+"',";
	userString=userString+"'"+toSafeString(account.bGroup)+"',";
	userString=userString+"'"+toSafeString(account.password)+"',";
	userString=userString+"'"+toSafeString(account.teacher)+"'";


   xhttp.onreadystatechange = function() {
	  if (this.readyState == 4 && this.status == 200) {
			console.log("Add account " + account.accountName + " result: " + this.responseText);
     }
	};
	console.log("Adding user " + account.accountName);
	xhttp.open("GET", "createAccount.php?userString=" + userString, true);
	xhttp.send();
}

function modifyAccount(account)
{
	var xhttp = new XMLHttpRequest();
	var userString="";
	userString=userString+"firstName="+toSafeString(account.firstName)+"&";
	userString=userString+"lastName="+toSafeString(account.lastName)+"&";
	userString=userString+"accountName="+toSafeString(account.accountName)+"&";
	userString=userString+"bGroup="+toSafeString(account.bGroup)+"&";
	userString=userString+"email="+toSafeString(account.email)+"&";
	userString=userString+"teacher="+toSafeString(account.teacher)+"&";
	userString=userString+"school="+toSafeString(account.school);


   xhttp.onreadystatechange = function() {
	  if (this.readyState == 4 && this.status == 200) {
			console.log("Modify account " + account.accountName + " result: " + this.responseText);
     }
	};
	console.log("Modifying user " + account.accountName);
	console.log(userString);
	xhttp.open("GET", "modifyAccount.php?" + userString, true);
	xhttp.send();
}

function setAccountPassword(account)
{
	var xhttp = new XMLHttpRequest();
	var userString="";
	userString=userString+"accountName="+toSafeString(account.accountName)+"&";
	userString=userString+"password="+toSafeString(account.password);


   xhttp.onreadystatechange = function() {
	  if (this.readyState == 4 && this.status == 200) {
			console.log("Set password " + account.accountName + " result: " + this.responseText);
     }
	};
	console.log("Set password " + account.accountName);
	xhttp.open("GET", "setAccountPassword.php?" + userString, true);
	xhttp.send();
}

function deleteAccount(account)
{
	var xhttp = new XMLHttpRequest();
	var userString="";
	userString=userString+"accountName="+toSafeString(account.accountName);
	

   xhttp.onreadystatechange = function() {
	  if (this.readyState == 4 && this.status == 200) {
			console.log("Delete account " + account.accountName + " result: " + this.responseText);
     }
	};
	console.log("Delete account " + account.accountName);
	xhttp.open("GET", "deleteAccount.php?" + userString, true);
	xhttp.send();
}


function loginWithCallback(account,callbackLoginSuccess,callbackLoginFail)
{
	var xhttp = new XMLHttpRequest();
	var userString="";
	var user;
	userString=userString+"accountName="+toSafeString(account.accountName)+"&";
	userString=userString+"password="+toSafeString(account.password);


   xhttp.onreadystatechange = function() {
	  if (this.readyState == 4 && this.status == 200) {
			console.log("Login result " + account.accountName + " result: " + this.responseText);
			if (this.responseText.substring(0,4)!="fail")
			{
				user=JSON.parse(toOrigString(xhttp.responseText));
				account.firstName=user[0].firstName;
				account.lastName=user[0].lastName;
				account.bGroup=user[0].bGroup;
				account.email=user[0].email;
				account.teacher=user[0].teacher;
				console.log("successful login");
				console.log(account);
				callbackLoginSuccess();
			} else {
				callbackLoginFail();
			}
			loginReady=true;

     }
	};
	loginReady=false;
	console.log("Login " + account.accountName);
	xhttp.open("GET", "login.php?" + userString, true);
	xhttp.send();
}


function getAllAccountsDefaultCallback()
{
	return 0;
}


function getAllAccounts()
{
	getAllAccountsWithCallback(getAllAccountsDefaultCallback);
}

function getAllAccountsWithCallback(callback)
{
  var xhttp = new XMLHttpRequest();
  xhttp.onreadystatechange = function() {
    if (xhttp.readyState == 4 && xhttp.status == 200) {
		console.log(xhttp.responseText);
		console.log(toOrigString(xhttp.responseText));
		allUserAccountList=JSON.parse(toOrigString(xhttp.responseText));
		allUserAccountListReady=true;
		callback();
    }
  };
   allUserAccountListReady=false;
   xhttp.open("GET", "getAllAccounts.php", true);
   xhttp.send();

}


function getAllRoomsDefaultCallback()
{
	return 0;
}


function getAllRooms()
{
	getAllRoomsWithCallback(getAllRoomsDefaultCallback);
}

function getAllRoomsWithCallback(callback)
{
  var xhttp = new XMLHttpRequest();
  xhttp.onreadystatechange = function() {
    if (xhttp.readyState == 4 && xhttp.status == 200) {
		console.log(xhttp.responseText);
		console.log(toOrigString(xhttp.responseText));
		allRoomsList=JSON.parse(toOrigString(xhttp.responseText));
		allRoomsListReady=true;
		callback();
    }
  };
   allRoomsListReady=false;
   xhttp.open("GET", "getAllRooms.php", true);
   xhttp.send();

}


